function dP, N, X

  f = ((-N*X * legendre(X,N))+(N*legendre(X,N-1)))/(1d0-(X^2d0));
  return, f

end

pro gaussleg, n, y ,w
;y and w are outputs

nl=1

x = findgen(1e5,start=-1,increment=2/(1e5-1d0))
x = signum(x) * sqrt(abs(x))
f = legendre(x,n)
x0 = x[where(reverse(ts_diff(reverse(signum(f)),1)) ne 0)]

y=x0
y0=y+1.0e3

i=0;
while max(abs(y0-y)) gt 1e-15 and i lt 1.0e3 do begin
  i++;
  y0=y;
  y = y0 - (legendre(y0,n)/dP(n,y0))
endwhile

w = 2d0/((1d0-(y^2d0))*(dP(n,y)^2d0))

end