function nrlmsise00_arr,date,utc,alt_arr,geo_lat,geo_long,f107_daily=f107_daily,$
      ap_daily=ap_daily,f107_3month=f107_3month
  if (keyword_set(alt_arr) eq 0) then alt_arr=findgen(71)/70*350+50
  geo_coor=[geo_lat,geo_long]
  utc=utc
  ;idoy=doy(fix(strmid(date,0,2)),fix(strmid(date,2,2)),fix(strmid(date,4,4)))
  idoy = 1 + julday(fix(strmid(date,0,2)),fix(strmid(date,2,2)),fix(strmid(date,4,4))) - julday(1,1,fix(strmid(date,4,4)))
  day_sec=utc*3600.0
  iyear=fix(strmid(date,4,4))
  lyear=strmid(date,4,4)
  
  if finite(ap_daily) eq 0 then ap_daily = 0d0

  iloc=geo_coor[1]*24.0/360.0+utc
  if (iloc gt 24.0) then iloc=iloc-24.0
  atm_nd=fltarr(n_elements(alt_arr))
  atm_md=atm_nd & atm_m=atm_nd & atm_nt=atm_nd & atm_O=atm_nd & atm_N2=atm_nd
  atm_O2=atm_nd & atm_he=atm_nd & atm_ar=atm_nd & atm_hh=atm_nd & atm_n=atm_nd
  atm_ao=atm_nd
  for ia=0,n_elements(alt_arr)-1 do begin
    if finite(f107_3month) AND finite(f107_daily) then begin
      iatm_data=idl_nrlmsise([double(idoy),double(iyear),double(day_sec),double(alt_arr[ia]),$
        double(geo_coor[0]),double(geo_coor[1]),double(iloc),double(f107_3month),double(f107_daily),$
        double(ap_daily)])
    endif else begin
      iatm_data = fltarr(11) + !values.d_nan
    endelse
    atm_he[ia]=iatm_data[0] & atm_O[ia]=iatm_data[1] & atm_n2[ia]=iatm_data[2]
    atm_O2[ia]=iatm_data[3]
    atm_Ar[ia]=iatm_data[4] & atm_md[ia]=iatm_data[5] & atm_HH[ia]=iatm_data[6]
    atm_N[ia]=iatm_data[7]
    atm_ao[ia]=iatm_data[8] & atm_nt[ia]=iatm_data[10]
    atm_nd[ia]=atm_o[ia]+atm_n2[ia]+atm_o2[ia]+atm_he[ia]+atm_ar[ia]+atm_hh[ia]+atm_n[ia]
    ;print,[double(idoy),double(iyear),double(day_sec),double(echaim_alt_arr[ia]),$
    ;double(geo_coor[0]),double(geo_coor[1]),double(iloc),double(if107),double(if107_81),$
    ;double(iap)]
    ;print,iatm_data
  endfor
  atm_mm=atm_md/atm_nd*6.02252e23
  atm_struct={h:alt_arr,nd:atm_nd,md:atm_md,m:atm_mm,nt:atm_nt,o:atm_o,N2:atm_n2,$
    O2:atm_o2,HE:atm_he,AR:atm_ar,HH:atm_hh,N:atm_N,AO:atm_ao}
  return,atm_struct
end

