function second_time_pars, latitudes, longitudes, altitudes,time_vector

; --- Start by loading the solar activity and geomagnetic activity data

caldat, time_vector,month_uses ,day_uses,year_uses,hour_uses,minute_uses,second_uses

yrsec = (julday(month_uses,day_uses,year_uses,hour_uses,minute_uses,second_uses)-julday(01,01,year_uses,00,00,00))*24.0*3600.0

zenith_outs = fltarr(n_elements(latitudes))

;counti = 0.0
for i = 0L, n_elements(latitudes)-1L do begin

;if (i)mod(floor(n_elements(latitudes)/300.0)) eq 0 then begin
;print, [counti,300]
;counti = counti +1
;endif

latitude = latitudes(i)
longitude = longitudes(i)
altitude = altitudes(i)
year_use = year_uses(i)
month_use = month_uses(i)
day_use = day_uses(i)
hour_use = hour_uses(i)
minute_use = minute_uses(i)
second_use = second_uses(i)
yrsec_use = yrsec(i)

if (year_use gt 1900) then yr=year_use-1900

dy=floor(yrsec_use/(24.0*3600.0))+1;round(julday(month_use,day_use,year_use,00,00,00)-julday(01,00,year_use,00,00,00));
ut=float(yrsec_use-((dy-1)*24.0*3600.0))/3600.0;(time_vector(i)-julday(month_use,day_use,year_use,00,00,00));
zensun_echaim,dy,ut,latitude,longitude,zenith1,azimuth,solfac,sunrise=sunrise, latsun=latsun1,lonsun=lonsun1
zenith_outs(i) = zenith1
;et = eqn_of_time2(lonsun1, yr)/3600.0

endfor

out_struct = {F:zenith_outs}
;out_struct = {A:mlt_outs,B:mlat_outs,C:mlon_outs, D: modip_outs, E: inclen_outs, F:zenith_outs,G:F107_outs,H:SSN_outs,J:kp_outs,K:mlt_juls_outs, L:ig_outs, M:ig12_outs, N:F107_81_outs, O:F107_365_outs, Q:F107_1_outs}

return, out_struct

;print, 'the'

end