function calc_CHAIM_model_parameters_for_perturb_NmF2_2018,MLON_in,MLAT_in, jul_day_in,slz_in,f107_in,SSN_in,modip_in,inclen_in,ig_in,ig12_in,f107_81_in,f107_365_in,int_dst_in,int_ap_in,dipoles,int_AE_in,MLT_in
; MLT in hours.
; MLAT in degrees.
; F107 in flux units.
; jul_day_in the julian ut time stamp associated with the data.

;MLT_degrees = MLT_in/24.0*360.0
MLON_u = MLON_in;MLT_degrees
f107_in1 = f107_81_in

caldat, jul_day_in, monthin,dayin,yearin,hourin,minutein,secondin
cos_factor = cos((90.0-MLAT_in)*!PI/45.0)
;cos_factor = cos(MLAT_in*!PI/180.0)
DoY_in = jul_day_in-julday(01,01,yearin,00,00,00)
DoY_in=float(floor(DoY_in))
cos_slz = cos(slz_in*!PI/180.0)
sin_dipoles = sin(dipoles)
cos_dipoles = cos(dipoles)

;test_index = where(int_dst_in lt 0.0, cnt)
;if cnt gt 0 then begin
;int_dst_in(test_index) = 0.0
;endif

ff3 = exp(int_dst_in/300.0); <-- Top contender;int_dst_in; 10.0^(int_dst_in/750.0);exp(int_dst_in/50.0);exp(int_dst_in/300.0);*exp(-int_ap_in/30.0)
ff1 = exp(-int_ap_in/30.0);+exp(-int_AE_in/700.0); <-- Top contender
ff2 = exp(int_AE_in/700.0)
;ff1 = exp(-int_ap_in/30.0)
;ff1 = exp(int_AE_in/700.0)
;ff2 = sin_dipoles;int_dst_in
;ff1 = int_ap_in
;ff2 = int_Q_in


;ff1 = int_dst_in

;print, 'sol_ac_start'
;sol_ac_function = non_linear_solar_activity_for_fit(MLAT_in,f107_in1,hourin)
;print, 'sol_ac_done'

for a = 0, 5 do begin
a1 = a
for b = 0,min([a,3]) do begin
b1 = b

Plm = Legendre(cos_factor,a1,b1)

;for c = 0,1 do begin
;;carr = [0.2,0.25,(1.0/3.0),0.5,1.0]
;;carr = [0.25,(1.0/3.0),0.5,1.0]
;carr = [0.5,1.0]
;c1 = carr(c)

if b1 eq 0 then begin

;c1 = 1.0
;p8 = ff1*f107_in1*Plm*cos(!PI*b1*MLON_u/180.0)*sin((DoY_in*(2.0*!PI))/(365.25*c1));*sin_dipoles
p12 = ff1*sqrt(f107_in1)*Plm*cos(!PI*b1*MLON_u/180.0)*sin_dipoles
p22 = ff1*Plm*cos(!PI*b1*MLON_u/180.0)*sin_dipoles
;p8x = ff1*f107_in1*Plm*cos(!PI*b1*MLON_u/180.0)*cos((DoY_in*(2.0*!PI))/(365.25*c1));*sin_dipoles
p12x = ff1*sqrt(f107_in1)*Plm*cos(!PI*b1*MLON_u/180.0)*cos_dipoles
p22x = ff1*Plm*cos(!PI*b1*MLON_u/180.0)*cos_dipoles
;p7 = ff2*f107_in1*Plm*cos(!PI*b1*MLON_u/180.0)*sin((DoY_in*(2.0*!PI))/(365.25*c1));*sin_dipoles
p11 = ff2*sqrt(f107_in1)*Plm*cos(!PI*b1*MLON_u/180.0)*sin_dipoles
p23 = ff2*Plm*cos(!PI*b1*MLON_u/180.0)*sin_dipoles
;p7x = ff2*f107_in1*Plm*cos(!PI*b1*MLON_u/180.0)*cos((DoY_in*(2.0*!PI))/(365.25*c1));*sin_dipoles
p11x = ff2*sqrt(f107_in1)*Plm*cos(!PI*b1*MLON_u/180.0)*cos_dipoles
p23x = ff2*Plm*cos(!PI*b1*MLON_u/180.0)*cos_dipoles

;p107 = ff3*f107_in1*Plm*cos(!PI*b1*MLON_u/180.0)*sin((DoY_in*(2.0*!PI))/(365.25*c1));*sin_dipoles
p111 = ff3*sqrt(f107_in1)*Plm*cos(!PI*b1*MLON_u/180.0)*sin_dipoles
p123 = ff3*Plm*cos(!PI*b1*MLON_u/180.0)*sin_dipoles
;p107x = ff3*f107_in1*Plm*cos(!PI*b1*MLON_u/180.0)*cos((DoY_in*(2.0*!PI))/(365.25*c1));*sin_dipoles
p111x = ff3*sqrt(f107_in1)*Plm*cos(!PI*b1*MLON_u/180.0)*cos_dipoles
p123x = ff3*Plm*cos(!PI*b1*MLON_u/180.0)*cos_dipoles


;p7 = ff2*f107_in1*Plm*cos(!PI*b1*MLON_u/180.0);*sin_dipoles
;p11 = ff2*sqrt(f107_in1)*Plm*cos(!PI*b1*MLON_u/180.0);*sin_dipoles
;p8 = ff1*f107_in1*Plm*cos(!PI*b1*MLON_u/180.0);*sin_dipoles
;p12 = ff1*sqrt(f107_in1)*Plm*cos(!PI*b1*MLON_u/180.0);*sin_dipoles
;;p15 = ff3*f107_in1*Plm*cos(!PI*b1*MLON_u/180.0);*sin_dipoles
;;p16 = ff3*sqrt(f107_in1)*Plm*cos(!PI*b1*MLON_u/180.0);*sin_dipoles
;
;p22 = ff1*Plm*cos(!PI*b1*MLON_u/180.0);*sin_dipoles
;p23 = ff2*Plm*cos(!PI*b1*MLON_u/180.0);*sin_dipoles
;;p24 = ff3*Plm*cos(!PI*b1*MLON_u/180.0);*sin_dipoles

;ppp = [[p8],[p12],[p22],[p7],[p11],[p23],[p8x],[p12x],[p22x],[p7x],[p11x],[p23x]];,[p15],[p16],[p24]]

;ppp = [[p12],[p22],[p11],[p23],[p12x],[p22x],[p11x],[p23x]];,[p15],[p16],[p24]]
ppp = [[p12],[p22],[p11],[p23],[p12x],[p22x],[p11x],[p23x],[p111],[p123],[p111x],[p123x]]

;ppp = [[p12],[p22],[p12x],[p22x]]
;ppp = [[p12],[p22],[p12x],[p22x]]
endif else begin

;c1 = 1.0
;p8 = ff1*f107_in1*Plm*sin(!PI*b1*MLON_u/180.0)*sin((DoY_in*(2.0*!PI))/(365.25*c1));*sin_dipoles
;p9 = ff1*f107_in1*Plm*cos(!PI*b1*MLON_u/180.0)*sin((DoY_in*(2.0*!PI))/(365.25*c1));*sin_dipoles
p12 = ff1*sqrt(f107_in1)*Plm*sin(!PI*b1*MLON_u/180.0)*sin_dipoles
p13 = ff1*sqrt(f107_in1)*Plm*cos(!PI*b1*MLON_u/180.0)*sin_dipoles
p36 = ff1*Plm*sin(!PI*b1*MLON_u/180.0)*sin_dipoles
p37 = ff1*Plm*cos(!PI*b1*MLON_u/180.0)*sin_dipoles
;p8x = ff1*f107_in1*Plm*sin(!PI*b1*MLON_u/180.0)*cos((DoY_in*(2.0*!PI))/(365.25*c1));*sin_dipoles
;p9x = ff1*f107_in1*Plm*cos(!PI*b1*MLON_u/180.0)*cos((DoY_in*(2.0*!PI))/(365.25*c1));*sin_dipoles
p12x = ff1*sqrt(f107_in1)*Plm*sin(!PI*b1*MLON_u/180.0)*cos_dipoles
p13x = ff1*sqrt(f107_in1)*Plm*cos(!PI*b1*MLON_u/180.0)*cos_dipoles
p36x = ff1*Plm*sin(!PI*b1*MLON_u/180.0)*cos_dipoles
p37x = ff1*Plm*cos(!PI*b1*MLON_u/180.0)*cos_dipoles
;p6 = ff2*f107_in1*Plm*sin(!PI*b1*MLON_u/180.0)*sin((DoY_in*(2.0*!PI))/(365.25*c1));*sin_dipoles
;p7 = ff2*f107_in1*Plm*cos(!PI*b1*MLON_u/180.0)*sin((DoY_in*(2.0*!PI))/(365.25*c1));*sin_dipoles
p10 = ff2*sqrt(f107_in1)*Plm*sin(!PI*b1*MLON_u/180.0)*sin_dipoles
p11 = ff2*sqrt(f107_in1)*Plm*cos(!PI*b1*MLON_u/180.0)*sin_dipoles
p38 = ff2*Plm*sin(!PI*b1*MLON_u/180.0)*sin_dipoles
p39 = ff2*Plm*cos(!PI*b1*MLON_u/180.0)*sin_dipoles
;p6x = ff2*f107_in1*Plm*sin(!PI*b1*MLON_u/180.0)*cos((DoY_in*(2.0*!PI))/(365.25*c1));*sin_dipoles
;p7x = ff2*f107_in1*Plm*cos(!PI*b1*MLON_u/180.0)*cos((DoY_in*(2.0*!PI))/(365.25*c1));*sin_dipoles
p10x = ff2*sqrt(f107_in1)*Plm*sin(!PI*b1*MLON_u/180.0)*cos_dipoles
p11x = ff2*sqrt(f107_in1)*Plm*cos(!PI*b1*MLON_u/180.0)*cos_dipoles
p38x = ff2*Plm*sin(!PI*b1*MLON_u/180.0)*cos_dipoles
p39x = ff2*Plm*cos(!PI*b1*MLON_u/180.0)*cos_dipoles


;p6 = ff3*f107_in1*Plm*sin(!PI*b1*MLON_u/180.0)*sin((DoY_in*(2.0*!PI))/(365.25*c1));*sin_dipoles
;p7 = ff3*f107_in1*Plm*cos(!PI*b1*MLON_u/180.0)*sin((DoY_in*(2.0*!PI))/(365.25*c1));*sin_dipoles
p110 = ff3*sqrt(f107_in1)*Plm*sin(!PI*b1*MLON_u/180.0)*sin_dipoles
p111 = ff3*sqrt(f107_in1)*Plm*cos(!PI*b1*MLON_u/180.0)*sin_dipoles
p138 = ff3*Plm*sin(!PI*b1*MLON_u/180.0)*sin_dipoles
p139 = ff3*Plm*cos(!PI*b1*MLON_u/180.0)*sin_dipoles
;p6x = ff3*f107_in1*Plm*sin(!PI*b1*MLON_u/180.0)*cos((DoY_in*(2.0*!PI))/(365.25*c1));*sin_dipoles
;p7x = ff3*f107_in1*Plm*cos(!PI*b1*MLON_u/180.0)*cos((DoY_in*(2.0*!PI))/(365.25*c1));*sin_dipoles
p110x = ff3*sqrt(f107_in1)*Plm*sin(!PI*b1*MLON_u/180.0)*cos_dipoles
p111x = ff3*sqrt(f107_in1)*Plm*cos(!PI*b1*MLON_u/180.0)*cos_dipoles
p138x = ff3*Plm*sin(!PI*b1*MLON_u/180.0)*cos_dipoles
p139x = ff3*Plm*cos(!PI*b1*MLON_u/180.0)*cos_dipoles




;p6 = ff2*f107_in1*Plm*sin(!PI*b1*MLON_u/180.0);*sin_dipoles
;p7 = ff2*f107_in1*Plm*cos(!PI*b1*MLON_u/180.0);*sin_dipoles
;p10 = ff2*sqrt(f107_in1)*Plm*sin(!PI*b1*MLON_u/180.0);*sin_dipoles
;p11 = ff2*sqrt(f107_in1)*Plm*cos(!PI*b1*MLON_u/180.0);*sin_dipoles
;p8 = ff1*f107_in1*Plm*sin(!PI*b1*MLON_u/180.0);*sin_dipoles
;p9 = ff1*f107_in1*Plm*cos(!PI*b1*MLON_u/180.0);*sin_dipoles
;p12 = ff1*sqrt(f107_in1)*Plm*sin(!PI*b1*MLON_u/180.0);*sin_dipoles
;p13 = ff1*sqrt(f107_in1)*Plm*cos(!PI*b1*MLON_u/180.0);*sin_dipoles
;p55 = ff3*f107_in1*Plm*sin(!PI*b1*MLON_u/180.0);*sin_dipoles
;p56 = ff3*f107_in1*Plm*cos(!PI*b1*MLON_u/180.0);*sin_dipoles
;p57 = ff3*sqrt(f107_in1)*Plm*sin(!PI*b1*MLON_u/180.0);*sin_dipoles
;p58 = ff3*sqrt(f107_in1)*Plm*cos(!PI*b1*MLON_u/180.0);*sin_dipoles


;p36 = ff1*Plm*sin(!PI*b1*MLON_u/180.0);*sin_dipoles
;p37 = ff1*Plm*cos(!PI*b1*MLON_u/180.0);*sin_dipoles
;p38 = ff2*Plm*sin(!PI*b1*MLON_u/180.0);*sin_dipoles
;p39 = ff2*Plm*cos(!PI*b1*MLON_u/180.0);*sin_dipoles
;p40 = ff3*Plm*sin(!PI*b1*MLON_u/180.0);*sin_dipoles
;p41 = ff3*Plm*cos(!PI*b1*MLON_u/180.0);*sin_dipoles

;ppp = [[p8],[p9],[p12],[p13],[p36],[p37],[p6],[p7],[p10],[p11],[p38],[p39]];,[p8x],[p9x],[p12x],[p13x],[p36x],[p37x],[p6x],[p7x],[p10x],[p11x],[p38x],[p39x]];,[p55],[p56],[p57],[p58],[p40],[p41]]


;ppp = [[p12],[p13],[p36],[p37],[p10],[p11],[p38],[p39],[p12x],[p13x],[p36x],[p37x],[p10x],[p11x],[p38x],[p39x]]
ppp = [[p12],[p13],[p36],[p37],[p10],[p11],[p38],[p39],[p12x],[p13x],[p36x],[p37x],[p10x],[p11x],[p38x],[p39x],[p110],[p111],[p138],[p139],[p110x],[p111x],[p138x],[p139x]]


;ppp = [[p12],[p13],[p36],[p37],[p12x],[p13x],[p36x],[p37x]]
;ppp = [[p12],[p13],[p36],[p37],[p12x],[p13x],[p36x],[p37x]]
endelse

;if c lt 1 then begin
;ppp = [pp]
;endif else begin
;ppp = [[ppp],[pp]]
;endelse
;endfor


if b lt 1 then begin
pppss = [ppp]
endif else begin
pppss = [[pppss],[ppp]]
endelse

endfor

if a lt 1 then begin
pppsss = [pppss]
endif else begin
pppsss = [[pppsss],[pppss]]
endelse

endfor

;pppsss = [[pppsss],[f107_in1*cos_slz],[f107_in1^2.0*cos_slz],[sol_ac_function*cos_slz],[sol_ac_function*sin(slz_in*!PI/180.0)],[f107_in1*sin(slz_in*!PI/180.0)],[ig_in*sin(slz_in*!PI/180.0)],[ig_in*cos_slz]]
;pppsss = [[pppsss],[f107_in1*cos_slz],[f107_in1^2.0*cos_slz],[sqrt(f107_in1)*cos_slz],[sqrt(f107_in1)*sin(slz_in*!PI/180.0)],[f107_in1*sin(slz_in*!PI/180.0)],[ig_in*sin(slz_in*!PI/180.0)],[ig_in*cos_slz]]
;pppsss = [[pppsss],[sin(f107_in1)],[cos(f107_in1)]]

arg = 1.0

outsarr = {vars: pppsss, kpindexs:arg, kpcounts:arg, kp_out:arg}

return, outsarr


end