function dipole_tilt_interface, Jul_info_in

; INPUT: JUL_INFO_IN - juldian time stamps in UTC. This variable can be a scalar or a vector (if scalar, just use dipole_tilt_calc.pro instead though). 

caldat, jul_info_in,smonth,sday,syear,shour,smin,ssecond

dip_tilts = fltarr(n_elements(Jul_info_in))

for i = 0L, n_elements(Jul_info_in) - 1L do begin
dip_tilts(i) = dipole_tilt_calc(2000d0,smonth(i),sday(i),shour(i),smin(i),ssecond(i))
endfor

return, dip_tilts

end