function energy_spectrum,echar,alpha,erange,n_elem=n_elem,log_op=log_op,kappa_op=kappa_op

;alpha=1
;erange=[0.1,400.0]
;n_elem=1000
;log_op=1
;kappa_op=0

;N(E)dE=E^alpha*exp(-E/Echar)*dE
;keV
;if (keyword_set(n_elem) eq 0) then n_elem=1000
if (keyword_set(log_op) eq 1) then begin
  ener_arr=10^(findgen(n_elem)/(n_elem-1)*(alog10(erange[1])-alog10(erange[0]))+alog10(erange[0]))
endif ;else begin
  ;ener_arr=findgen(n_elem)/(n_elem-1)*(erange[1]-erange[0])+erange[0]
;endelse
if (keyword_set(kappa_op) eq 0) then begin
  eflux=Ener_arr^alpha*exp(-Ener_arr/Echar[0])/int_tabulated(ener_arr,Ener_arr^alpha*exp(-Ener_arr/Echar[0]))
endif ;else begin
  ;eflux=Ener_arr*(1+ener_arr/(alpha*echar))^(-1*alpha-1)/int_tabulated(ener_arr,$
  ;  Ener_arr*(1+ener_arr/(alpha*echar))^(-1*alpha-1))
;endelse

return,{flux:eflux,energy:ener_arr}

end