function gauss_energy_spectrum, energy_mean, wt
 
erange=[0.01d0,400d0]
alpha = 1d0
n_elem = 10d0
n_seg = 10d0

erange = 10d0^(dindgen(n_seg) / (n_seg-1d0) * (alog10(erange[1]) - alog10(erange[0])) + alog10(erange[0]))

gaussleg,n_elem,x,w

n = n_elements(erange)
energy = fltarr(n_elements(erange)*(n-1)) + !values.d_nan
wt = energy
for i=0, n-2 do begin
  energy[i*n:(i*n)+(n-1)] = (((x+1)/2d0)*(erange[i+1]-erange[i]))+erange[i]
  wt[i*n:(i*n)+(n-1)] = 0.5d0*w*(erange[i+1]-erange[i])
endfor

flux = energy^alpha*exp(-energy/energy_mean)
flux = flux / total(flux*wt)

return, {energy:energy,flux:flux,w:w}


end