function generalized_integrate_geomag_param, tau,juls_na,gm_param,n_int

; n_int must be much larger than 2*24*60/resolution, where resolution is the data resolution in minutes

n_dst = n_elements(gm_param)-1L
;intergrated_param = (1.0-tau)*(tau^0.0*gm_param[27:*]+$
;tau^1.0*gm_param[26:n_dst-1]+ tau^2.0*gm_param[25:n_dst-2]+ tau^3.0*gm_param[24:n_dst-3]+ tau^4.0*gm_param[23:n_dst-4]+ tau^5.0*gm_param[22:n_dst-5]+ tau^6.0*gm_param[21:n_dst-6]+ tau^7.0*gm_param[20:n_dst-7]+ tau^8.0*gm_param[19:n_dst-8]+ tau^9.0*gm_param[18:n_dst-9]+ $
;tau^10.0*gm_param[17:n_dst-10]+ tau^11.0*gm_param[16:n_dst-11]+ tau^12.0*gm_param[15:n_dst-12]+ tau^13.0*gm_param[14:n_dst-13]+ tau^14.0*gm_param[13:n_dst-14]+ tau^15.0*gm_param[12:n_dst-15]+ tau^16.0*gm_param[11:n_dst-16]+ tau^16.0*gm_param[10:n_dst-17]+ tau^18.0*gm_param[9:n_dst-18]+ $
;tau^19.0*gm_param[8:n_dst-19]+ tau^20.0*gm_param[7:n_dst-20]+ tau^21.0*gm_param[6:n_dst-21]+ tau^22.0*gm_param[5:n_dst-22]+ tau^23.0*gm_param[4:n_dst-23]+ tau^24.0*gm_param[3:n_dst-24]+ tau^25.0*gm_param[2:n_dst-25]+ tau^26.0*gm_param[1:n_dst-26]+ tau^27.0*gm_param[0:n_dst-27])

for i = 0L,n_int do begin
inter_param = (1.0-tau)*((tau^i)*gm_param[(n_int-i):(n_dst-i)])
if i eq 0 then intergrated_param = inter_param else intergrated_param = intergrated_param + inter_param
endfor

;jul_int = juls_na[27:*]
jul_int = juls_na[n_int:*]

return, [[intergrated_param],[jul_int]]

end